diff --git a/gcc/config/arm/neon.md b/gcc/config/arm/neon.md
index e8db020..99caf96 100644
--- a/gcc/config/arm/neon.md
+++ b/gcc/config/arm/neon.md
@@ -4265,7 +4265,7 @@ if (BYTES_BIG_ENDIAN)
   HOST_WIDE_INT max = GET_MODE_NUNITS (<MODE>mode);
   operands[3] = GEN_INT (lane);
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   if (max == 1)
     return "vld1.<V_sz_elem>\t%P0, %A1";
   else
@@ -4287,7 +4287,7 @@ if (BYTES_BIG_ENDIAN)
   operands[3] = GEN_INT (lane);
   int regno = REGNO (operands[0]);
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -4373,7 +4373,7 @@ if (BYTES_BIG_ENDIAN)
   HOST_WIDE_INT max = GET_MODE_NUNITS (<MODE>mode);
   operands[2] = GEN_INT (lane);
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   if (max == 1)
     return "vst1.<V_sz_elem>\t{%P1}, %A0";
   else
@@ -4394,7 +4394,7 @@ if (BYTES_BIG_ENDIAN)
   HOST_WIDE_INT max = GET_MODE_NUNITS (<MODE>mode);
   int regno = REGNO (operands[1]);
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -4465,7 +4465,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[4];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = gen_rtx_REG (DImode, regno);
   ops[1] = gen_rtx_REG (DImode, regno + 2);
   ops[2] = operands[1];
@@ -4490,7 +4490,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[4];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -4580,7 +4580,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[4];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = operands[0];
   ops[1] = gen_rtx_REG (DImode, regno);
   ops[2] = gen_rtx_REG (DImode, regno + 2);
@@ -4605,7 +4605,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[4];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -4724,7 +4724,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[5];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = gen_rtx_REG (DImode, regno);
   ops[1] = gen_rtx_REG (DImode, regno + 2);
   ops[2] = gen_rtx_REG (DImode, regno + 4);
@@ -4751,7 +4751,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[5];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -4896,7 +4896,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[5];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = operands[0];
   ops[1] = gen_rtx_REG (DImode, regno);
   ops[2] = gen_rtx_REG (DImode, regno + 2);
@@ -4923,7 +4923,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[5];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -5046,7 +5046,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[6];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = gen_rtx_REG (DImode, regno);
   ops[1] = gen_rtx_REG (DImode, regno + 2);
   ops[2] = gen_rtx_REG (DImode, regno + 4);
@@ -5074,7 +5074,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[0]);
   rtx ops[6];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;
@@ -5226,7 +5226,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[6];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   ops[0] = operands[0];
   ops[1] = gen_rtx_REG (DImode, regno);
   ops[2] = gen_rtx_REG (DImode, regno + 2);
@@ -5254,7 +5254,7 @@ if (BYTES_BIG_ENDIAN)
   int regno = REGNO (operands[1]);
   rtx ops[6];
   if (lane < 0 || lane >= max)
-    error ("lane out of range");
+    internal_error ("lane out of range");
   else if (lane >= max / 2)
     {
       lane -= max / 2;